unit URainForm;

interface

uses
  Windows, Messages, SysUtils, {Variants,} Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, ShellApi, StdActns, ActnList, Menus, StdCtrls, ExtCtrls,
  Grids, ComCtrls, Clipbrd, jpeg;
type
  TSerialArrayE = array of TEdit;
  TValuesArrayE = array of TEdit;
  TRainForm = class(TBaseForm)
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    Edit: TMenuItem;
    Copy: TMenuItem;
    Cut: TMenuItem;
    Paste: TMenuItem;
    InputOpenDialog: TOpenDialog;
    InputSaveDialog: TSaveDialog;
    PageControl1: TPageControl;
    IntroTabSheet: TTabSheet;
    InputTabSheet: TTabSheet;
    EditDelete1: TEditDelete;
    IntroMemo: TMemo;
    FileExit1: TFileExit;
    FileNameEdit: TEdit;
    Title2Edit: TEdit;
    TimeLabel: TLabel;
    RainLabel: TLabel;
    OutputOpenDialog: TOpenDialog;
    InputSaveAction: TAction;
    InputOpenAction: TAction;
    OutputOpenAction: TAction;
    FileNameLabel: TLabel;
    Title1Label: TLabel;
    Title2Label: TLabel;
    OptionComboBox: TComboBox;
    OptionLabel: TLabel;
    InputOpenButton: TButton;
    InputSaveButton: TButton;
    InputOpenMenu: TMenuItem;
    FileItem: TMenuItem;
    OutputOpenMenu: TMenuItem;
    InputSaveMenu: TMenuItem;
    ProgramExit: TMenuItem;
    Title1Edit: TEdit;
    NrOfDataLabel: TLabel;
    NrOfDataEdit: TEdit;
    StringGrid1: TStringGrid;
    GraphOpenDialog: TOpenDialog;
    GraphOpenMenu: TMenuItem;
    GraphOpenAction: TAction;
    GraphicsTabSheet: TTabSheet;
    SeeGraphButton: TButton;
    OutputTabSheet: TTabSheet;
    SeeOutputButton: TButton;
    OutputMemo: TMemo;
    ViewGraphButton: TButton;
    MakeGraphButton: TButton;
    SaveGraphButton: TButton;
    GraphSaveDialog: TSaveDialog;
    HelpGroupBox: TGroupBox;
    FirstButton: TButton;
    SecondButton: TButton;
    AlphaButton: TButton;
    HeadButton: TButton;
    FirstMemo: TMemo;
    SecondMemo: TMemo;
    AlphaMemo: TMemo;
    HeadMemo: TMemo;
    BackButton: TButton;
    FigureTabSheet: TTabSheet;
    RunoffLabel: TLabel;
    FirstGroupBox: TGroupBox;
    InitStorLabel: TLabel;
    InitStorEdit: TEdit;
    MaxStorLabel: TLabel;
    MaxStorEdit: TEdit;
    EscapeLabel: TLabel;
    EscapeEdit: TEdit;
    AlphaGroupBox: TGroupBox;
    A1Label: TLabel;
    B1Label: TLabel;
    A1coeffEdit: TEdit;
    B1valueEdit: TEdit;
    PredictGroupBox: TGroupBox;
    InitRunLabel: TLabel;
    InitRunEdit: TEdit;
    InitLevelEdit: TEdit;
    InitLevelLabel: TLabel;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    RunoffRadioButton: TRadioButton;
    RechRadioButton: TRadioButton;
    AlphaRadioButton: TRadioButton;
    Panel2: TPanel;
    RadioGroup2: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    OutputOpenForGraphics: TAction;
    Savegraph: TMenuItem;
    GraphSaveAction: TAction;
    WaitMemo: TMemo;
    SelectButton: TButton;
    CalcObsRadioButton: TRadioButton;
    GraphImage: TImage;
    PictureImage: TImage;
    InputImage: TImage;
    HelpButton: TButton;
    CommentButton: TButton;
    RainRunRadioButton: TRadioButton;
    AlfaMemo: TMemo;
    AlfaButton: TButton;
    Panel3: TPanel;
    RadioGroup3: TRadioGroup;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GoButton3: TButton;
    GoButton2: TButton;
    GoButton1: TButton;
    ClearButton: TButton;
    RefMemo: TMemo;
    Reservoir_Image: TImage;
    PorosityEdit: TEdit;
    PorosityLabel: TLabel;
    DivideEdit: TEdit;
    DivideLabell: TLabel;
    DivideLabel: TLabel;
    A2Label: TLabel;
    B2Label: TLabel;
    A2CoeffEdit: TEdit;
    B2ValueEdit: TEdit;
    AlphaLabel: TLabel;
    TryMemo: TMemo;
    EvapLabel: TLabel;
    StarLabel: TLabel;
    {Start}
    procedure FormCreate(Sender: TObject);
    procedure IntroTabSheetShow(Sender: TObject);
    procedure FirstButtonClick(Sender: TObject);
    procedure SecondButtonClick(Sender: TObject);
    procedure HeadButtonClick(Sender: TObject);
    procedure AlphaButtonClick(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    {Input}
    procedure InputTabSheetShow(Sender: TObject);
    procedure InputOpenActionExecute(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol,
                        ARow: Integer; const Value: String);
    procedure HandlePasteMultiCell(Sender: TObject; ACol,
                        ARow: Integer; const Value: String);
    procedure NrOfDataEditExit(Sender: TObject);
    procedure OptionComboBoxChange(Sender: TObject);
    procedure OptionComboBoxExit(Sender: TObject);
    procedure MaxStorEditExit(Sender: TObject);
    function  StringToFloat(Str : string) : double;
    procedure InitStorEditExit(Sender: TObject);
    procedure EscapeEditExit(Sender: TObject);
    procedure A1coeffEditExit(Sender: TObject);
    procedure A2coeffEditExit(Sender: TObject);
    procedure B1valueEditExit(Sender: TObject);
    procedure B2valueEditExit(Sender: TObject);
    procedure AlfaButtonClick(Sender: TObject);
    procedure InitRunEditExit(Sender: TObject);
    procedure PorosityEditExit(Sender: TObject);
    procedure InitLevelEditExit(Sender: TObject);
    procedure DivideEditExit(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure InputSaveActionExecute(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    {Output}
    procedure OutputTabSheetShow(Sender: TObject);
    procedure OutputOpenActionExecute(Sender: TObject);
    {graphics}
    procedure GraphicsTabSheetShow(Sender: TObject);
    procedure ShowGraphicsTab;
    procedure OutputOpenForGraphicsExecute(Sender: TObject);
    procedure GraphOpenActionExecute(Sender: TObject);
    procedure ShowGraphics;
    procedure GraphSaveActionExecute(Sender: TObject);
    procedure ViewGraphButtonClick(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure GoButton1Click(Sender: TObject);
    procedure GoButton2Click(Sender: TObject);
    procedure GoButton3Click(Sender: TObject);
    procedure CommentButtonClick(Sender: TObject);
    {Close}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    NoSave, GraphOpened,
    OutputOpened, Import,
    OutputOpenedForGraphics   : boolean;
    InitNrOfData, TmpNrOfData : integer;
    InitDir                   : string;
    TypeOfGraph               : byte;
    procedure EnterData;
    function SetAndVerifySaveName : boolean;
    procedure DoCalculations;
    procedure SetInitialDir (AuxDir:string);
  public
    InputOpened:boolean;
    { Public declarations }
  end;

var
  RainForm: TRainForm;
  InitDecSep : char;

implementation

uses UDMRainOff, UCommentForm, UFinishForm, UHelpForm, URainOffUtils,
     URainRun, UPrediction, UAlfaForm;

{$R *.dfm}


{----------------------------------------------------------------------
 START
 ----------------------------------------------------------------------}


procedure TRainForm.FormCreate(Sender: TObject);
begin
  inherited;
      PageControl1.ActivePageIndex := 0;     {Introduction tabsheet}
      getdir (0,InitDir);
      RainForm.InputOpenDialog.InitialDir:=InitDir;
      RainForm.InputSaveDialog.InitialDir:=InitDir;
      RainForm.OutputOpenDialog.InitialDir:=InitDir;
      RainForm.GraphOpenDialog.InitialDir:=GetCurrentDir;
      RainForm.GraphSaveDialog.InitialDir:=GetCurrentDir;
      InputOpened := false;
      OutputOpened := false;
      GraphOpened := false;
      OutputOpenedForGraphics := false;
      FileNameLabel.Visible := false;
      FileNameEdit.Visible := false;
      StringGrid1.EditorMode := true;
      LX := posX2-posX1;
      LY := posY2-posY1;
      Left := 100;
      If screen.Width > 675 then
            Width := 675
      else if screen.Width < width then
      begin
            Left:=10;
            Width := screen.Width-10;
      end;
      InitDecSep := DecimalSeparator;
end;{TRainForm.FormCreate}


{----------------------------------------------------------------------
 INTRO
 ----------------------------------------------------------------------}


procedure TRainForm.IntroTabSheetShow(Sender: TObject);
begin
  inherited;
  {hier wordt de IntroMemo getoond}
    if OptionComboBox.ItemIndex=0 then
    begin
      DMRainOff.Analysis := true;
      DMRainOff.Code:=' Ana';
      DMRainOff.LinQua := ' Lin';
      AlfaMemo.Visible:=false;
      AlfaButton.Visible:=false;
    end;
    if OptionComboBox.ItemIndex=1 then
    begin
      DMRainOff.Analysis := false;
      DMRainOff.Code:=' Pre';
      AlfaMemo.Visible:=true;
      AlfaButton.Visible:=true;
    end;
    StatusText ('Click on the Input tab to proceed.');
    InputSaveAction.Enabled := false;
    GraphSaveAction.Enabled := false;
    IntroMemo.Visible := true;
    FirstMemo.Visible := false;
    SecondMemo.Visible := false;
    AlphaMemo.Visible := false;
    HeadMemo.Visible := false;
    CommentForm.Visible := false;
    CommentButton.Enabled := false;
    OutputOpenedForGraphics := false;
    if DMRainOff.MaxStor=0 then DMRainOff.MaxStor:=50;
    if DMRainOff.InitStor=0 then DMRainOff.InitStor:=50;
    if DMRainOff.EscRate=0 then DMRainOff.EscRate:=0.1;
end; {TRainForm.IntroTabSheetShow}


procedure TRainForm.FirstButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    FirstMemo.Visible := true;
    SecondMemo.Visible := false;
    AlphaMemo.Visible := false;
    HeadMemo.Visible := false;
end; {TRainForm.FirstButtonClick}


procedure TRainForm.SecondButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    FirstMemo.Visible := false;
    SecondMemo.Visible := true;
    AlphaMemo.Visible := false;
    HeadMemo.Visible := false;
end; {TRainForm.SecondButtonClick}


procedure TRainForm.AlphaButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    FirstMemo.Visible := false;
    SecondMemo.Visible := false;
    AlphaMemo.Visible := true;
    HeadMemo.Visible := false;
end; {TRainForm.AlphaButtonClick}


procedure TRainForm.HeadButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    FirstMemo.Visible := false;
    SecondMemo.Visible := false;
    AlphaMemo.Visible := false;
    HeadMemo.Visible := true;
end; {TRainForm.HeadButtonClick}


procedure TRainForm.BackButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := true;
    FirstMemo.Visible := false;
    SecondMemo.Visible := false;
    AlphaMemo.Visible := false;
    HeadMemo.Visible := false;
end; {TRainForm.BackButtonClick}


{----------------------------------------------------------------------
 INPUT
 ----------------------------------------------------------------------}

{see also InputOpenAcxtionExecute and InputSaveActionExecute in the MenuItems
 at the end}

procedure TRainForm.InputTabSheetShow(Sender: TObject);
var i : integer;
    j : string;
begin
  inherited;
      StatusText('Enter data or use "Open input" to see examples under' +
            ' "Data" or to edit existing files. Thereafter use' +
            ' "Save/Run".');
      InputSaveAction.Enabled := true;
      GraphSaveAction.Enabled := false;
      OutputOpenedForGraphics := false;
      CommentForm.Visible := false;
      CommentButton.Enabled := false;
      if not InputOpened then
      begin
        FileNameLabel.Visible:=false;
        FileNameEdit.Visible:=false;
        DMRainOff.Analysis := true;
        OptionComboBox.ItemIndex := 0;
        InitNrOfData:=15;
        DMRainOff.NrOfData:=15;
        StringGrid1.ColCount := 4;
        StringGrid1.RowCount := 15;
        SetLength(DMRainOff.Time,DMRainOff.NrOfData+1);
        SetLength(DMRainOff.Rain,DMRainOff.NrOfData+1);
        SetLength(DMRainOff.Evap,DMRainOff.NrOfData+1);
        SetLength(DMRainOff.Runoff,DMRainOff.NrOfData+1);
        AlphaGroupBox.Visible := false;
        PredictGroupBox.Visible := false;
        DMRainOff.Drainage := false;
        TimeLabel.Left := 151;
        RainLabel.Left := 217;
        EvapLabel.Left := 281;
        RunoffLabel.Left := 365;
        StringGrid1.Left := 150;
        StringGrid1.Width := 282;
        AlfaMemo.Visible:=false;
        AlfaButton.Visible:=false;
        for i:=1 to 15 do
        begin
          j:=inttostr(i);
          StringGrid1.Cells[0,i-1]:= j;
        end;
        Starlabel.Top:=180;
        Starlabel.Left:=424;
        EnterData;
      end;
end; {TRainForm.InputTabSheetShow}


procedure TRainForm.StringGrid1SetEditText(Sender: TObject; ACol,
                    ARow: Integer; const Value: String);
{---------------------------------------------------------------}
var MultiPaste:boolean;
begin
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('An insufficient number of data has been pasted'+
                     ' more data are needed.');
        InputTabsheet.Show;
        exit;
      end;
    end;
  end;
  Import:=true;
  NrOfDataEditExit(Sender);
  setlength (DMRainOff.FileLine,6);
  Import := false;
  InputOpened := true;
end; {TSegRegForm.StringGrid1SetEditText}
{---------------------------------------}



procedure TRainForm.HandlePasteMultiCell(Sender: TObject; ACol,
                    ARow: Integer; const Value: String);
{-------------------------------------------------------------}
// only accepts numbers to be pasted into the grid
  var
   i, m, j, Kr, StartCol, StartRow: integer;
   c: char ;
   Result : boolean;

begin
  // MessageDlg(Value, mtInformation, [mbOK], 0);
  m := Length(Value);
  (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
  StartCol := ACol ;
  StartRow := ARow;
  i := 1;
  Kr:=1;
  while i <= m do begin
  // loop through the characters of the Value string
    c := Value[i];
    j := Integer(c);
    if j = 9 then
    begin // tab: Move to next column
      ACol := ACol + 1 ;
      if i < m then // empty the cell if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else if j = 13 then
    begin // CR - is followed by LF
         // Move to next row, jump back to startcolumn
      StringGrid1.RowCount:=Kr;
      Kr:=Kr+1;
      ARow := ARow + 1 ;
      ACol := startcol ;
      i := i + 1 ; // skip the LF
      if i < m then // empty the cell it if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else // add the character to the string in the cell if a number
    if c in [DecimalSeparator,'-',#48,#49,#50,#51,#52,#53,#54,#55,#56,#57] then
        (Sender as TStringGrid).Cells[ACol,ARow] :=
          ConCat((Sender as TStringGrid).Cells[ACol,ARow], c);
    i := i + 1 ;
  end;
//  StringGrid1.ColCount:=Kc;
  StringGrid1.RowCount:=StringGrid1.RowCount+StartRow;
  NrOfDataEdit.Text:=IntToStr(StringGrid1.RowCount);
  DMRainOff.NrOfData:=StringGrid1.RowCount;
  if DMRainOff.NrOfData<InitNrOfData then
  begin
    Result := DMRainOff.Question('The number of data is less than the original'+
              ' number. Do you want to maintain the original number?');
    if Result then
    begin
      DMRainOff.NrOfData:=InitNrOfData;
      StringGrid1.RowCount:=InitNrOfData;
    end;
  end;
  with DMRainOff do
  begin
    NrOfData:=StringGrid1.RowCount;
    NrOfDataEdit.Text := inttostr(NrOfData);
    setlength (Time,NrOfData+1);
    setlength (Rain,NrOfData+1);
    setlength (Evap,NrOfData+1);
    Analysis:=true;
    if StringGrid1.ColCount = 3 then Analysis:=false;
    if Analysis then setlength (RunOff,NrOfData+1);
    for i:=0 to NrOfData-1 do
    begin
      Time[i]:=StrToInt(StringGrid1.Cells[0,i]);
      Rain[i]:=StringToFloat(StringGrid1.Cells[1,i]);
      Evap[i]:=StringToFloat(StringGrid1.Cells[2,i]);
      DecimalSeparator := InitDecSep;
      if Analysis then RunOff[i]:=StringToFloat(StringGrid1.Cells[3,i]);
    end; {for i:=0 to NrOfData-1 do}
    setlength (ToBeRemoved,NrOfData+1);
    for i:=0 to NrOfData-1 do ToBeRemoved[i]:=false;
    if Analysis then
    begin
      AlphaGroupBox.Visible := false;
      PredictGroupBox.Visible := false;
      RunOffLabel.Visible := true;
      TimeLabel.Left := 151;
      RainLabel.Left := 217;
      EvapLabel.Left := 281;
      RunoffLabel.Left := 365;
      StringGrid1.Left := 150;
      StringGrid1.Width := 282;
      OptionComboBox.ItemIndex:=0;
    end else
    begin
      AlphaGroupBox.Visible := true;
      PredictGroupBox.Visible := true;
      RunOffLabel.Visible := false;
      TimeLabel.Left := 86;
      RainLabel.Left := 152;
      EvapLabel.Left := 204;
      StringGrid1.ColCount := 3;
      StringGrid1.Left := 72;
      StringGrid1.Width := 218;
      OptionComboBox.ItemIndex := 1;
    end;
  end; {with DMSegReg do}
  InitNrOfData:=DMRainOff.NrOfData;
end; {TSegRegForm.HandlePasteMultiCell}
{-------------------------------------}


procedure TRainForm.EnterData;
var k, Finish: integer;
begin
      NrOfDataEdit.Text:=IntToStr(DMRainOff.NrOfData);
      Finish := DMRainOff.NrOfData;
      StringGrid1.RowCount := Finish;
      SetLength(DMRainOff.ToBeRemoved,Finish+1);
      setlength(DMRainOff.Time,Finish+1);
      setlength(DMRainOff.Rain,Finish+1);
      setlength(DMRainOff.Evap,Finish+1);
      if InputOpened then
      begin
         MaxStorEdit.Text := FloatToStr(DMRainOff.MaxStor);
         InitStorEdit.Text := FloatToStr(DMRainOff.InitStor);
         EscapeEdit.Text := FloatToStr(DMRainOff.EscRate);
          if DMRainOff.Analysis then
          begin
            OptionComboBox.ItemIndex:=0;
            AlphaGroupBox.Visible := false;
            PredictGroupBox.Visible := false;
            RunOffLabel.Visible := true;
            TimeLabel.Left := 151;
            RainLabel.Left := 217;
            EvapLabel.Left := 281;
            RunoffLabel.Left := 365;
            StringGrid1.Left := 150;
            StringGrid1.Width := 282;
            StringGrid1.ColCount := 4;
            AlfaMemo.Visible:=false;
            AlfaButton.Visible:=false;
            TryMemo.Visible:=true;
            StarLabel.Left:=432;
            StarLabel.Top:=180;
            EvapLabel.Left:=281;
          end else
          begin
            OptionComboBox.ItemIndex:=1;
            AlphaGroupBox.Visible := true;
            PredictGroupBox.Visible := true;
            RunOffLabel.Visible := false;
            TimeLabel.Left := 86;
            RainLabel.Left := 152;
            EvapLabel.Left := 200;
            StarLabel.Left:=285;
            StarLabel.Top:=175;
            StringGrid1.ColCount := 3;
            StringGrid1.Left := 72;
            StringGrid1.Width := 219;
            StringGrid1.ColCount := 3;
            A1coeffEdit.Text := FloatToStr(A1coeff);
            A2coeffEdit.Text := FloatToStr(A2coeff);
            B1valueEdit.Text := FloatToStr(B1value);
            B2valueEdit.Text := FloatToStr(B2value);
            if DMRainOff.EffPor=0 then DMRainOff.EffPor:=10;
            InitRunEdit.Text := FloatToStr(DMRainOff.InitRun);
            InitLevelEdit.Text := FloatToStr(DMRainOff.InitLevel);
            PorosityEdit.Text := FloatToStr(DMRainOff.EffPor);
            DivideEdit.Text := FloatToStr(RunRef);
          end;
      end;

      if not InputOpened then
      begin
          if DMRainOff.Analysis then
          begin
            AlphaGroupBox.Visible := false;
            PredictGroupBox.Visible := false;
            RunOffLabel.Visible := true;
            TimeLabel.Left := 151;
            RainLabel.Left := 217;
            EvapLabel.Left := 281;
            RunoffLabel.Left := 365;
            StringGrid1.Left := 150;
            StringGrid1.Width := 282;
            StringGrid1.ColCount := 4;
          end else
          begin
            AlphaGroupBox.Visible := true;
            PredictGroupBox.Visible := true;
            RunOffLabel.Visible := false;
            TimeLabel.Left := 86;
            RainLabel.Left := 152;
            EvapLabel.Left := 204;
            StringGrid1.ColCount := 3;
            StringGrid1.Left := 72;
            StringGrid1.Width := 219;
            A1coeffEdit.Text := FloatToStr(A1coeff);
            A2coeffEdit.Text := FloatToStr(A2coeff);
            B1valueEdit.Text := FloatToStr(B1value);
            B2valueEdit.Text := FloatToStr(B2value);
            if DMRainOff.EffPor=0 then DMRainOff.EffPor:=10;
            InitRunEdit.Text := FloatToStr(DMRainOff.InitRun);
            InitLevelEdit.Text := FloatToStr(DMRainOff.InitLevel);
            PorosityEdit.Text := FloatToStr(DMRainOff.EffPor);
            DivideEdit.Text := FloatToStr(RunRef);
          end;
      end;
      for k:=1 to Finish do DMRainOff.ToBeRemoved[k] := false;
      for k := 0 to Finish-1 do
      begin
        StringGrid1.RowHeights[k] := 20;
        if not InputOpened then
        begin
          StringGrid1.Cells[0,k] := '0';
          StringGrid1.Cells[1,k] := '0';
          StringGrid1.Cells[2,k] := '0';
          StringGrid1.Cells[3,k] := '0';
        end else
        begin
          StringGrid1.Cells[0,k] := FloatToStr(DMRainOff.Time[k]);
          StringGrid1.Cells[1,k] := FloatToStr(DMRainOff.Rain[k]);
          StringGrid1.Cells[2,k] := FloatToStr(DMRainOff.Evap[k]);
          if DMRainOff.Analysis then
            StringGrid1.Cells[3,k] := FloatToStr(DMRainOff.RunOff[k]);
        end;
      end;
      if InputOpened and DMRainOff.Analysis
                     and (DMRainOff.RunOff[Finish-1]=0) then
         showmessage ('Please check the runoff data.');
      InitNrOfData:=DMRainOff.NrOfData;
      TmpNrOfData:=InitNrOfData;
      if InputOpened then InputTabsheet.Show;
end; {TRainForm.EnterData}


procedure TRainForm.HelpButtonClick(Sender: TObject);
begin
  inherited;
  HelpForm.Visible:=true;
end;


procedure TRainForm.ClearButtonClick(Sender: TObject);
var i, j : integer;
begin
  inherited;
    A1coeffEdit.Text:='';
    A2coeffEdit.Text:='';
    B1valueEdit.Text:='';
    B2valueEdit.Text:='';
    InitRunEdit.Text:='';
    PorosityEdit.Text:=' 5 ';
    InitLevelEdit.Text:='';
    MaxStorEdit.Text:='';
    InitStorEdit.Text:='';
    EscapeEdit.Text:='';
    Title1Edit.Text:='';
    Title2Edit.Text:='';
    NrOfDataEdit.Text:='15';
    StringGrid1.rowcount:=15;
    if DMRainOff.Analysis then
    begin
      AlphaGroupBox.Visible := false;
      PredictGroupBox.Visible := false;
      RunOffLabel.Visible := true;
      TimeLabel.Left := 151;
      RainLabel.Left := 217;
      EvapLabel.Left := 281;
      RunoffLabel.Left := 365;
      StringGrid1.Left := 150;
      StringGrid1.Width := 282;
      StringGrid1.ColCount := 4;
      OptionComboBox.ItemIndex := 0;
    end else
    begin
      AlphaGroupBox.Visible := true;
      PredictGroupBox.Visible := true;
      RunOffLabel.Visible := false;
      TimeLabel.Left := 86;
      RainLabel.Left := 152;
      EvapLabel.Left := 204;
      StringGrid1.Left := 72;
      StringGrid1.Width := 219;
      StringGrid1.ColCount := 3;
      OptionComboBox.ItemIndex := 1;
    end;
    for i:=0 to 2 do for j:=1 to 15 do
        StringGrid1.Cells[i,j-1]:='0';
    InputOpened:=false;
end;


procedure TRainForm.NrOfDataEditExit(Sender: TObject);
var NumDat, k: integer;
begin
  inherited;
    Try
      NumDat := StrToInt(NrOfDataEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The number of data is not a valid integer');
        exit;
      end;
    end;
    if NumDat<12 then
    begin
      Showmessage (' The minimum number of data is 12');
      NrOfDataEdit.Text:='12';
      exit;
    end;
    if NumDat>1500 then
    begin
      Showmessage (' The maximum number of data is 1500. Not enough?'+
                   ' Contact the author.');
      NrOfDataEdit.Text:='1500';
      exit;
    end;
    if Numdat<DMRainOff.NrOfData then
    for k:=Numdat-1 to DMRainOff.NrOfData-1 do
        SetLength(DMRainOff.SerialNr,k+1);
    if not Import and (NumDat>InitNrOfData) then
    begin
       Showmessage (' Add data in the last cells at the end of the column');
       for k:=InitNrOfData to NumDat do
       begin
         SetLength(DMRainOff.SerialNr,k+1);
         SetLength(DMRainOff.Time,k+1);
         SetLength(DMRainOff.Rain,k+1);
         SetLength(DMRainOff.Evap,k+1);
         SetLength(DMRainOff.RunOff,k+1);
         DMRainOff.SerialNr[k]:= k+1;
         DMRainOff.Time[k]:= 0;
         DMRainOff.Rain[k]:= 0;
         DMRainOff.Evap[k]:= 0;
         DMRainOff.RunOff[k]:= 0;
       end;
       DMRainOff.NrOfData := NumDat;
       EnterData;
    end;
    if not Import and (NumDat<InitNrOfData) then
       Showmessage (' To remove data make the relevant data cells empty');
end; {TRainForm.NrOfDataEditExit}


procedure TRainForm.OptionComboBoxChange(Sender: TObject);
begin
  inherited;
  InputImage.Visible:=false;
  if OptionComboBox.ItemIndex=0 then DMRainOff.Analysis := true
     else DMRainOff.Analysis := false;
  InputOpened := true;
  if DMRainOff.Analysis then StringGrid1.ColCount:=4
     else StringGrid1.ColCount:=3;
  if DMRainOff.Analysis then DMRainOff.Code:=' Ana'
     else DMRainOff.Code:=' Pre';
  EnterData;
end; {TRainForm.OptionComboBoxChange}


procedure TRainForm.OptionComboBoxExit(Sender: TObject);
begin
  inherited;
    if OptionComboBox.ItemIndex=0 then
    begin
      DMRainOff.Code:=' Ana';
      AlfaMemo.Visible:=false;
      AlfaButton.Visible:=false;
    end else
    begin
      DMRainOff.Code:=' Pre';
      AlfaMemo.Visible:=true;
      AlfaButton.Visible:=true;
    end;
end;


procedure TRainForm.MaxStorEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(MaxStorEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The maximum storage is not a valid real');
        MaxStorEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if HlpVar<0 then
  begin
    Showmessage ('The maximum storage must be >= 0');
    MaxStorEdit.Text := '0';
  end;
  DMRainOff.MaxStor := HlpVar;
end; {TRainForm.MaxStorEditExit}


function TRainForm.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator := OldDecSep;
    end;
  end;
end; {TSegRegForm.StringToFloat}


procedure TRainForm.InitStorEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(InitStorEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The initial storage is not a valid real');
        InitStorEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if HlpVar<0 then
  begin
    Showmessage ('The initial storage must be >= 0');
    MaxStorEdit.Text := '0';
  end;
  DMRainOff.InitStor := HlpVar;
end; {TRainForm.InitStorEditExit}


procedure TRainForm.EscapeEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(EscapeEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The escape rate is not a valid real');
        EscapeEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if (OptionComboBox.ItemIndex=0) and (HlpVar<0) then
  begin
    Showmessage ('The escape rate must be >= 0');
    EscapeEdit.Text := '0';
    HlpVar := 0;
  end;
  DMRainOff.EscRate := HlpVar;
end; {TRainForm.EscapeEditExit}


procedure TRainForm.A1coeffEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(A1coeffEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The A1 coefficient is not a valid real');
        A1coeffEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  A1coeff := HlpVar;
end; {TRainForm.A1coeffEditExit}


procedure TRainForm.A2coeffEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(A2coeffEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The A2 coefficient is not a valid real');
        A2coeffEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  A2coeff := HlpVar;
end; {TRainForm.A2coeffEditExit}


procedure TRainForm.B1valueEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(B1valueEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The B1 value is not a valid real');
        B1valueEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  B1value := HlpVar;
end; {TRainForm.B1valueEditExit}


procedure TRainForm.B2valueEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(B2valueEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The B2 value is not a valid real');
        B2valueEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  B2value := HlpVar;
end; {TRainForm.B2valueEditExit}


procedure TRainForm.InitRunEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(InitRunEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The initial runoff is not a valid real');
        InitRunEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if HlpVar<0 then
  begin
    Showmessage ('The initial runoff must be >= 0');
    InitRunEdit.Text := '0';
  end;
  DMRainOff.InitRun := HlpVar;
end; {TRainForm.InitRunEditExit}


procedure TRainForm.InitLevelEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(InitLevelEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The initial level is not a valid real');
        InitLevelEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if HlpVar<0 then
  begin
    Showmessage ('The initial level must be >= 0');
    InitLevelEdit.Text := '0';
  end;
  DMRainOff.InitLevel := HlpVar;
end; {TRainForm.InitLevelEditExit}


procedure TRainForm.PorosityEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(PorosityEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The porosity is not a valid real');
        PorosityEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if HlpVar<0 then
  begin
    Showmessage ('The porosity must be >= 0');
    PorosityEdit.Text := ' 5';
  end;
  if HlpVar>100 then
  begin
    Showmessage ('The porosity must be < 100%');
    PorosityEdit.Text := ' 5';
  end;
  DMRainOff.EffPor := HlpVar;
end; {TRainForm.PorosityEditExit}


procedure TRainForm.DivideEditExit(Sender: TObject);
var HlpVar : real;
begin
  inherited;
    Try
      HlpVar := StringToFloat(DivideEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The divide is not a valid real');
        DivideEdit.Text := '0';
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
  if HlpVar<0 then
  begin
    Showmessage ('The divide must be >= 0');
    PorosityEdit.Text := ' 0';
  end;
  RunRef:=HlpVar;
end;


function TRainForm.SetAndVerifySaveName;
begin Inherited;
      NoSave:=false;
      Result := false;
      if InputSaveDialog.Execute then
      begin DMRainOff.FileName := InputSaveDialog.Files.Strings[0];
            If FileExists(DMRainOff.FileName)
            then  Result := DMRainOff.
                        Question('The file already exists, overwrite?')
            else  Result := true;
      end
      else NoSave:=true;
end; {TRainForm.SetAndVerifySaveName}


{ See InputSaveActionExecute in the MenuItems group at the end}


procedure TRainForm.DoCalculations;
begin
  if DMRainOff.Analysis then
  begin
    RainRunOff;
    if not TimeVar or NoZero then exit;
    RadioButton4.Caption:='Watertable in time';
  end else
  begin
    StorOK:=true;
    if DmRainOff.Drainage then RadioButton4.Caption:='Watertable in time'
    else
       RadioButton4.Caption:='Reservoir storage';
    Predict;
    TimeVar:= not FalseTime;
    if not TimeVar or Nozero then exit;
    WaitMemo.Lines.Add(' Calculating .....');
    Sleep(500);
    WaitMemo.Lines.Add(' Progress 75% ....');
  end;
  if Scarce or DMRainOff.NoRange then
  begin
    NoSave:=true;
    exit;
  end;
  if Problem1 or Problem2 or Problem3 then if not noWrite and not Note then
     showmessage ('RainOff may not give a satisfactory solution'+
                  ' owing to particular, uncommon, data or anomalies.');
  Sleep(500);
  NoSave := false;
end; {TRainForm.DoCalculations}


procedure TRainForm.SetInitialDir (AuxDir:string);
begin
      InputOpenDialog.InitialDir:=AuxDir;
      InputSaveDialog.InitialDir:=AuxDir;
      OutputOpenDialog.InitialDir:=AuxDir;
      GraphSaveDialog.InitialDir:=AuxDir;
      GraphOpenDialog.InitialDir:=AuxDir;
end; {SetInitialDir}


 {---------------------------------------------------------------------
 End of Input, start of OUTPUT
 ----------------------------------------------------------------------}


procedure TRainForm.OutputTabSheetShow(Sender: TObject);
begin
  inherited;
        if not OutputOpened then
           ViewGraphButton.Visible := false
        else
           ViewGraphButton.Visible := true;
        InputSaveAction.Enabled := false;
        GraphSaveAction.Enabled := false;
        OutputOpenedForGraphics := false;
        CommentForm.Visible := false;
        CommentButton.Enabled := false;
        StatusText ('The output file can be inspected. Use "Open output"' +
                    ' to see examples under "Data" or to inspect any other' +
                    ' output file.');
end; {TRainForm.OutputTabSheetShow}


procedure TRainForm.ViewGraphButtonClick(Sender: TObject);
begin
  inherited;
      OutputOpenedForGraphics:= true;
      SelectButton.Enabled := false;
      PictureImage.Visible:= false;
      GraphicsTabsheet.Show;
end; {TRainForm.ViewGraphButtonClick}

{ see also OutputOpenActionExecute in the Menu Items at the end}

{-----------------------------------------------------------------------
 End of Output, start of Graphics
 -----------------------------------------------------------------------}


procedure TRainForm.GraphicsTabSheetShow(Sender: TObject);
begin
  inherited;
    Statustext ('Graphics presentations of output data can be seen and saved.'+
               ' Use "Make graph" to open an output file and make the graphs.');
    InputSaveAction.Enabled := false;
    GraphSaveAction.Enabled := false;
    SeeGraphButton.Visible := true;
    GraphImage.Visible:= false;
    PictureImage.Visible:= false;
    CommentForm.Visible := false;
    CommentButton.Enabled := false;
    ShowGraphicsTab;
end; {TRainForm.GraphicsTabSheetShow}


procedure TRainForm.SelectButtonClick(Sender: TObject);
begin
  inherited;
  GraphImage.Visible:= false;
  SelectButton.Enabled := false;
  CommentForm.Visible := false;
  CommentButton.Enabled := false;
  ShowGraphicsTab;
end; {TRainForm.SelectButtonClick}


procedure TRainForm.ShowGraphicsTab;
begin
    GraphSaveAction.Enabled := false;
    if not OutputOpenedForGraphics then
    begin
      Panel1.Visible := false;
      Panel2.Visible := false;
      Panel3.Visible := false;
      SelectButton.Enabled := false;
    end else
    begin
      DMRainOff.ReadOutputIndex;
      if DMRainOff.Index='----' then
      begin
         Panel1.Visible := true;
         Panel2.Visible := false;
         Panel3.Visible := false;
      end else
      begin
         Panel1.Visible := false;
         Panel2.Visible := false;
         Panel3.Visible := true;
      end;
    end;
    SeeGraphButton.Visible := true;
    if not DMRainOff.Analysis then
       if DMRainOff.Drainage then RadioButton4.Caption:='Watertable in time'
       else RadioButton4.Caption:='Reservoir storage';
end; {ShowGraphicsTab}


procedure TRainForm.GoButton1Click(Sender: TObject);
begin
  inherited;
  CommentForm.Visible := false;
  CommentButton.Enabled := false;
  if RunOffRadioButton.Checked then  TypeOfGraph := 1
  else if RechRadioButton.Checked then TypeOfGraph := 3
  else if AlphaRadioButton.Checked then TypeOfGraph := 6
  else if CalcObsRadioButton.Checked then TypeOfGraph := 7
  else if RainRunRadioButton.Checked then
  begin
    CommentButton.Enabled:=true;
    TypeOfGraph := 8;
    ReadCoefficients;
  end else exit;
  DMRainOff.ReadOutputData(TypeOfGraph);
  Panel1.Visible := false;
  Panel2.Visible := false;
  Panel3.Visible := false;
  SelectButton.Enabled := true;
  ShowGraphics;
end;


procedure TRainForm.GoButton2Click(Sender: TObject);
begin
  inherited;
  if RadioButton1.Checked then TypeOfGraph := 2
  else if RadioButton2.Checked then TypeOfGraph := 4
  else exit;
  DMRainOff.ReadOutputData(TypeOfGraph);
  Panel1.Visible := false;
  Panel2.Visible := false;
  Panel3.Visible := false;
  SelectButton.Enabled := true;
  ShowGraphics;
end;

procedure TRainForm.GoButton3Click(Sender: TObject);
begin
  inherited;
  if RadioButton3.Checked then TypeOfGraph := 2
  else if RadioButton4.Checked then TypeOfGraph := 5
  else if RadioButton5.Checked then TypeOfGraph := 4
  else exit;
  DMRainOff.ReadOutputData(TypeOfGraph);
  Panel1.Visible := false;
  Panel2.Visible := false;
  Panel3.Visible := false;
  SelectButton.Enabled := true;
  ShowGraphics;
end;


procedure TRainForm.CommentButtonClick(Sender: TObject);
begin
  inherited;
  CommentForm.Show;
end;

{ see also GraphOpenActionExecute under MENU ITEMS at the end}

procedure TRainForm.ShowGraphics;
var k, ii, Start: integer;
    DumReal, XdatRel, YdatRel : real;
    NameStr, Astr, Bstr, Cstr, Totstr : string;
    myRect  : TRect;
begin
  GraphOpened := true;
  MakeGraphButton.Visible := true;
  GraphSaveAction.Enabled := true;
  MaxMin (TypeOfGraph);
  if TypeOfGraph=6 then OrderData;
  if TypeOfGraph=8 then Regress;
  Relative (TypeOfGraph);
  Legends (TypeOfGraph);
  With GraphImage.Canvas do with DMRainOff do
  begin
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,465);
    FillRect (myRect);
    Textout (105,5,DMRainOff.Title1);
    Font.Size := 8;
    TextOut (20,PosY2+60,'RainOff program at www.waterlog.info/rainoff.htm');
    Brush.Color := $8B0000;
    myRect:= Rect(20,19,605,445);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (105,20,DMRainOff.Title2);

    moveto (PosX1,PosY2);
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    if TypeOfGraph>5 then
       Textout (470,PosY2+25,LegendX)
    else
       Textout (510,PosY2+25,LegendX);

    if TypeOfGraph=1 then
    begin
      TextOut (PosX1+12,60,LegendY);
      NameStr:='R square = ' + floattostr(Rsq);
      if Rsq>0.5 then Textout (PosX1+375,60,NameStr);
      Font.Color := clAqua;
      TextOut (PosX1+25,75,LegendY1);
      Font.Color := clWhite;
      TextOut (PosX1+25,90,LegendY2);
    end;
    if (TypeOfGraph=2) then
       TextOut (PosX1+10,50,'Discharge (predicted) in mm/t');
    if (TypeOfGraph=3) or (TypeOfGraph=4) then
    begin
      TextOut (PosX1+15,60,' Rain/irrigation in mm/t');
      Font.Color:=clskyblue;
      TextOut (PosX1+16,75,' Recharge in mm/t');
      Font.Color:=clWhite;
    end;
    if (TypeOfGraph=5) then
    begin
      TextOut (PosX1+16,60,LegendY);
      Font.Color:=clWhite;
    end;
    if (TypeOfGraph=6) then
    begin
      TextOut (PosX1+12,60,LegendY);
      Font.Color := clAqua;
      TextOut (PosX1+16,75,LegendY1);
      Font.Color:=clWhite;
      TextOut (PosX1+16,90,LegendY2);
    end;
    if (TypeOfGraph=7) then
    begin
      TextOut (PosX1+12,60,LegendY);
      TextOut (PosX1+25,75,LegendY1);
      NameStr:='R square = ' + floattostr(Rsq);
      if Rsq>0.5 then Textout (PosX1+375,60,NameStr);
    end;
    if (TypeOfGraph=8) then
      TextOut (PosX1+12,60,LegendY);
    Start := 0;
    if ScaleY>10 then Start := ScaleY-10;
    for ii:=Start to ScaleY do                        { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                    { horizontal axis }
    for ii:=0 to ScaleX do
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+5);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+10, NameStr);
    end;

    for k:=0 to NrOfData-3 do
    begin
      if (TypeOfGraph=3) then
      begin
        Brush.Color := clskyblue;
        if RelYrData[k]+5<posY2 then
           FillRect(Rect(RelXdata[k+1],RelYrData[k],RelXdata[k+2],PosY2-1));
      end;
      if (TypeOfGraph=4) then
      begin
        Brush.Color := clskyblue;
        if RelYrData[k]+5<posY2 then
           FillRect(Rect(RelXdata[k],RelYrData[k],RelXdata[k+1],PosY2-1));
      end
    end;

    for k:=0 to NrOfData-3 do
    begin
      if (TypeOfGraph=1) then
      begin
        Font.Color:=clAqua;
        Font.Size:=10;
        Pen.Color:=claqua;
        ellipse (RelXdata[k+1]-2,RelZdata[k]-2,RelXdata[k+1]+2,RelZdata[k]+2);
        Pen.Color:=clwhite;
        moveto (RelXdata[k+1],RelYcdata[k]);
        lineto (RelXdata[k+2],RelYcdata[k+1]);
      end;
      if (TypeOfGraph=2) then
      begin
        moveto (RelXdata[k],RelYdata[k]);
        lineto (RelXdata[k+1],RelYdata[k+1]);
      end;
      if (TypeOfGraph=3) then
      begin
        Pen.Width := 2;
        if RelYData[k]+5<PosY2 then
        begin
          moveto (RelXdata[k+1],PosY2-2);
          lineto (RelXdata[k+1],RelYdata[k]);
          moveto (RelXdata[k+1],RelYData[k]);
          lineto (RelXdata[k+2],RelYData[k]);
          moveto (RelXdata[k+2],RelYData[k]);
          lineto (RelXdata[k+2],PosY2-2);
        end;
      end;
      if (TypeOfGraph=4) then
      begin
        if RelYcData[k]+5<posY2 then
        begin
          moveto (RelXdata[k],PosY2-1);
          lineto (RelXdata[k],RelYcdata[k]);
          moveto (RelXdata[k],RelYcData[k]);
          lineto (RelXdata[k+1],RelYcData[k]);
          moveto (RelXdata[k+1],RelYcData[k]);
          lineto (RelXdata[k+1],PosY2-1);
        end;
      end;
      if (TypeOfGraph=5) then
      begin
        moveto (RelXdata[k],RelHdata[k]);
        lineto (RelXdata[k+1],RelHdata[k+1]);
      end;
      if (TypeOfGraph=7) then
      begin
        Font.Size:=10;
        Font.Color:=clAqua;
        TextOut (RelXdata[k],RelYcdata[k]-5,#$95);
      end;
    end; {for k:=0 to NrOfData-2 do}
    if (TypeOfGraph=6) then for k:=0 to NrOfData-2 do
    begin
      Font.Size:=10;
      Font.Color:=clAqua;
      Pen.Color:=clAqua;
      ellipse (RelXdata[k]-2,RelYrdata[k]-2,RelXdata[k]+2,RelYrdata[k]+2);
      if k=NrOfData-2 then
        ellipse (RelXdata[k+1]-2,RelYrdata[k+1]-2,RelXdata[k+1]+2,
                 RelYrdata[k+1]+2);
      Pen.Color:=clWhite;
      if not Quadratic then
      begin
        if (Xdata[k]<RunRef) and (Xdata[k+1]>RunRef) then
           Pen.Style:=psDot
        else
           Pen.Style:=psSolid;
        moveto (RelXdata[k],RelYcdata[k]);
        lineto (RelXdata[k+1],RelYcdata[k+1]);
      end;
      if Quadratic then
      begin
        moveto (RelXdata[k],RelYcdata[k]);
        lineto (RelXdata[k+1],RelYcdata[k+1]);
      end;
    end;
    if (TypeOfGraph=7) then
    begin
      YdatRel := LY*(Ymin-MinY)/(MaxY-MinY);
      RelYdata[1] := PosY2-round(YdatRel)-5;
      XdatRel := LX*(Xmin-MinX)/(MaxX-MinX);
      RelXdata[1] := PosX1+round(XdatRel);
      YdatRel := LY*(Ymax/1.2-MinY)/(MaxY-MinY);
      RelYdata[2] := PosY2-round(YdatRel)-5;
      XdatRel := LX*(Xmax-MinX)/(MaxX-MinX);
      RelXdata[2] := PosX1+round(XdatRel);
      moveto (RelXdata[1],RelYdata[1]);
      lineto (RelXdata[2],RelYdata[2]);
    end;
    if (TypeOfGraph=8) then
    begin
      for k:=0 to NrOfData-1 do
          TextOut (RelYdata[k],RelZdata[k]-5,#$95);
      TextOut (PosX1+25,75,LegendY1);
      TextOut (PosX1+25,90,LegendY2);
      font.Color:=clyellow;
      if Qtrend then TextOut (PosX1+25,105,LegendY3);
      font.Color:=clwhite;
      OrderData;
      ReadCoefficients;
      RegRess;
      XdatRel := LX*(X1-MinX)/(MaxX-MinX);
      RelXdata[1] := PosX1+round(XdatRel);
      YdatRel := LY*(Y1-MinY)/(MaxY-MinY);
      RelYdata[1] := PosY2-round(YdatRel)-5;
        moveto (RelXdata[1],RelYrdata[1]);
      XdatRel := LX*(X2-MinX)/(MaxX-MinX);
      RelXdata[1] := PosX1+round(XdatRel);
      YdatRel := LY*(Y2-MinY)/(MaxY-MinY);
      RelYdata[1] := PosY2-round(YdatRel)-5;
        lineto (RelXdata[1],RelYrdata[1]);
    end; {if (TypeOfGraph=8) then}

    if (TypeOfGraph=8) and Qtrend then
    begin
      pen.Color:=clyellow;
      for k:=1 to 9 do
      begin
        Moveto (RelXpoint[k],RelQuadr[k]);
        Lineto (RelXpoint[k+1],RelQuadr[k+1]);
      end;
    end;
  end; {With GraphImage.Canvas do}
  GraphImage.Visible:=true;
end; {TRainForm.ShowGraphics}


{ see also GraphSaveActionExecute under Menu Items}


{-----------------------------------------------------------------------
 End of Graphics, start of FINISH
 -----------------------------------------------------------------------}


procedure TRainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
     Action := caNone;
     FinishForm.Show;
end; {TRainForm.FormClose}


{-----------------------------------------------------------------------
 End of Finish, start of MENU ITEMS
 -----------------------------------------------------------------------}

procedure TRainForm.InputOpenActionExecute(Sender: TObject);
var HlpTxt : string;
begin
  inherited;
     if RainForm.InputOpenDialog.Execute then
      begin
        DMRainOff.Filename := RainForm.InputOpenDialog.Files.Strings[0];
        if FileExists (DMRainOff.FileName) then
           DMRainOff.ReadInputFile
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        ShowMessage('No input file was selected');
        exit;
      end;
      HlpTxt:=inttostr(DMRainOff.NrOfData);
      NrOfDataEdit.Text:=HlpTxt;
      if DMRainOff.Drainage then
      begin
        AlfaMemo.Visible:=true;
        AlfaButton.Visible:=true;
      end else
      begin
        AlfaMemo.Visible:=false;
        AlfaButton.Visible:=false;
      end;
      FilenameEdit.Text := DMRainOff.FileName;
      FilenameEdit.Visible := true;
      FileNameLabel.Visible := true;
      InputImage.Visible:=false;
      CommentForm.Visible := false;
      CommentButton.Enabled := false;
      Title1Edit.Text := DMRainOff.Title1;
      Title2Edit.Text := DMRainOff.Title2;
      NrOfDataEdit.Text := IntToStr(DMRainOff.NrOfData);
      MaxStorEdit.Text := FloatToStr(DMRainOff.MaxStor);
      InitStorEdit.Text := FloatToStr(DMRainOff.InitStor);
      EscapeEdit.Text := FloatToStr(DMRainOff.EscRate);
      InputOpened := true;
      SetInitialDir (GetCurrentDir);
      EnterData;
end; {TRainForm.InputOpenActionExecute}


procedure TRainForm.InputSaveActionExecute(Sender: TObject);
label 1;
var i, k, N : integer;
    DataOK  : boolean;
    AuxFile : string;
    NumData : integer;
    Removed : boolean;
    Hlp : array of boolean;
    NN : array of integer;
begin
  inherited;
      if (OptionComboBox.ItemIndex=0) and
         (StringToFloat (EscapeEdit.Text)<0) then
      begin
        Showmessage ('The maximum escape rate cannot be negative.');
        exit;
      end;
      if (SetAndVerifySaveName) and not NoSave then
      begin
        DMRainOff.Title1 := Title1Edit.Text;
        DMRainOff.Title2 := Title2Edit.Text;
        NumData:=DMRainOff.NrOfData;
        if InitNrOfData>DMRainOff.NrOfData then
           NumData:=InitNrOfData;
        setlength(DMRainOff.ToBeRemoved,NumData+1);
        setlength(DMRainOff.Time,NumData+1);
        setlength(DMRainOff.Rain,NumData+1);
        setlength(DMRainOff.Evap,NumData+1);
        setlength(DMRainOff.RunOff,NumData+1);
        setlength(Hlp,NumData+1);
        setlength(NN,NumData+1);
        N:=0;
        Removed:=false;
        For k := 1 to DMRainOff.NrOfData do NN[k]:=0;
        For k := 1 to DMRainOff.NrOfData do
        begin
          Hlp[k-1]:=false;
          if DMRainOff.Analysis and (StringGrid1.Cells[2,k-1]<>'')
          then Hlp[k-1]:=true;
          if not DMRainOff.Analysis and (StringGrid1.Cells[1,k-1]<>'')
          then Hlp[k-1]:=true;
          if (StringGrid1.Cells[0,k-1]<>'') and
             (StringGrid1.Cells[1,k-1]<>'') and
             (StringGrid1.Cells[2,k-1]<>'') and
             Hlp[k-1]
          then
          begin
            Try
              begin
                DMRainOff.Time[k-1]:=
                  StringToFloat(StringGrid1.Cells[0,k-1]);
                DMRainOff.Rain[k-1]:=
                  StringToFloat(StringGrid1.Cells[1,k-1]);
                DMRainOff.Evap[k-1]:=
                  StringToFloat(StringGrid1.Cells[2,k-1]);
                if DMRainOff.Analysis then
                   DMRainOff.RunOff[k-1]:=
                     StringToFloat(StringGrid1.Cells[3,k-1]);
              end;
              Except on E: Exception do
              begin
                Showmessage ('Not all data values in the inputfile are real');
                exit;
              end;
            end;
            NN[k]:=1;
            N:=N+1;
          end else
          begin
            DMRainOff.ToBeRemoved[k]:=true;
            DMRainOff.NrOfData := DMRainOff.NrOfData-1;
            Removed:=true;
          end;
        end;
      end else
      begin
        Showmessage ('The input data were not saved');
        exit;
      end;
      DecimalSeparator := InitDecSep;

      NumData := StrToInt(NrOfDataEdit.Text);
      if Numdata<DMRainOff.NrOfData then
         for k:=Numdata-1 to DMRainOff.NrOfData-1 do
             SetLength(DMRainOff.SerialNr,k+1);
      if Numdata>DMRainOff.NrOfData then
         for k:=DMRainOff.NrOfData-1 to Numdata-1 do
             SetLength(DMRainOff.SerialNr,k+1);

      CheckData(DataOK);
      if not DataOK then
      begin
        Showmessage ('The input data were not saved due to input errors' +
                  ' like negative values or a non-sequential time series');
        exit;
      end;
      TmpNrOfData:=DMRainOff.NrOfData;
      DMRainOff.NrOfData:=InitNrOfData;

      if not DMRainOff.Analysis then
      begin
        A1Coeff:=stringtofloat(A1CoeffEdit.text);
        A2Coeff:=stringtofloat(A2CoeffEdit.text);
        B1value:=stringtofloat(B1valueEdit.text);
        B2value:=stringtofloat(B2valueEdit.text);
        RunRef :=stringtofloat(DivideEdit.text);
        DMRainOff.InitRun:=stringtofloat(InitRunEdit.text);
        DMRainOff.InitLevel:=stringtofloat(InitLevelEdit.text);
        DMRainOff.EffPor:=stringtofloat(PorosityEdit.text);
      end;

      DMRainOff.WriteInputFile(DMRainOff.FileName);
      if TmpNrOfData>0 then DMRainOff.NrOfData:=TmpNrOfData;

      NrOfDataEdit.Text:=inttostr(N);
      StringGrid1.rowcount:=N;
      i:=0;
      if Removed then for k:=1 to NumData do if NN[k]=1 then
      with DMRainOff do begin
          stringgrid1.Cells[0,k-1-i]:=floattostr(Time[k]);
          stringgrid1.Cells[1,k-1-i]:=floattostr(Rain[k]);
          stringgrid1.Cells[2,k-1-i]:=floattostr(Evap[k]);
          if Analysis then
             stringgrid1.Cells[3,k-1-i]:=floattostr(RunOff[k]);
      end else i:=i+1;

      WaitMemo.Visible:=true;
      WaitMemo.Lines.Clear;
      WaitMemo.Lines.Add(' Saving data .....');
      Sleep(500);
      WaitMemo.Lines.Add(' Progress 25% ....');
      if DMRainOff.Analysis then
      begin
        RunFactor:=0.3;
        TrialNr:=1;
        NoWrite:=true;
      end;
      DoCalculations;
      if not TimeVar or NoZero then
      begin
        WaitMemo.Lines.Clear;
        WaitMemo.Visible:=false;
        exit;
      end;
      if DMRainOff.Analysis then
      begin
        RunFactor:=0.4;
        TrialNr:=2;
        DoCalculations;
        WaitMemo.Lines.Add(' Progress 40% ....');
        TrialNr:=3;
        RunFactor:=0.5;
        DoCalculations;
        WaitMemo.Lines.Add(' Progress 60% ....');
        TrialNr:=4;
        RunFactor:=0.6;
        DoCalculations;
        WaitMemo.Lines.Add(' Progress 75% ....');
        TrialNr:=5;
        RunFactor:=0.7;
        DoCalculations;
        WaitMemo.Lines.Add(' Progress 90% ....');
        if (SumResSq13<SumResSq14+0.001) and (SumResSq13<SumResSq15+0.001)
            and (SumResSq13<SumResSq16+0.001) and (SumResSq13<SumResSq17+0.001)
            then begin RunFactor:=0.3; LowSq:=SumResSq13; goto 1; end;
        if (SumResSq14<SumResSq13+0.001) and (SumResSq14<SumResSq15+0.001)
            and (SumResSq14<SumResSq16+0.001) and (SumResSq14<SumResSq17+0.001)
            then begin RunFactor:=0.4; LowSq:=SumResSq14; goto 1; end;
        if (SumResSq15<SumResSq13+0.001) and (SumResSq15<SumResSq14+0.001)
            and (SumResSq15<SumResSq16+0.001) and (SumResSq15<SumResSq17+0.001)
            then begin RunFactor:=0.5; LowSq:=SumResSq15; goto 1; end;
        if (SumResSq16<SumResSq13+0.001) and (SumResSq16<SumResSq14+0.001)
            and (SumResSq16<SumResSq15+0.001) and (SumResSq16<SumResSq17+0.001)
            then begin RunFactor:=0.6; LowSq:=SumResSq16; goto 1; end;
        if (SumResSq17<SumResSq13+0.001) and (SumResSq17<SumResSq14+0.001)
            and (SumResSq17<SumResSq15+0.001) and (SumResSq17<SumResSq16+0.001)
            then begin RunFactor:=0.7; LowSq:=SumResSq17; goto 1; end;
1:      NoWrite:=false;
        DoCalculations;
      end;
      if not StorOK or FalseTime or DMRainOff.NoRange or NoSave then
      begin
        WaitMemo.Lines.Clear;
        WaitMemo.Visible:=false;
        DMRainOff.NoRange:=false;
        InputTabsheet.Show;
        exit;
      end;
      DMRainOff.FileName := ChangeFileExt(DMRainOff.FileName,'.out');
      DMRainOff.ReadOutputLines (DmRainOff.FileName);
      WaitMemo.Lines.Add(' Filing results ..');
      Sleep(500);
      WaitMemo.Visible:= false;
      AuxFile := ChangeFileExt(DMRainOff.FileName,'.inp');
      ShowMessage ('The input is saved in ' + AuxFile + ' ;' +
                   ' Calculations were done and the output is saved in  ' +
                     DMRainOff.FileName);
      OutputMemo.Lines.Clear;
      for k:=1 to DMRainOff.NrOfLines do
          OutputMemo.Lines.Add(DMRainOff.FileLine[k-1]);
     DmRainOff.OutputFileName:=DmRainOff.FileName;
     SetInitialDir (GetCurrentDir);
     OutputMemo.Visible:=true;
     OutputOpened := true;
     OutputOpenedForGraphics := true;
     OutputTabsheet.Show;
end; {TRainForm.InputSaveActionExecute}


procedure TRainForm.OutputOpenActionExecute(Sender: TObject);
var k : integer;
begin
  inherited;
  if OutputOpenDialog.Execute then
     begin
        DMRainOff.Filename := RainForm.OutputOpenDialog.Files.Strings[0];
        if FileExists (DMRainOff.Filename) then
          DMRainOff.ReadOutputLines (DMRainOff.FileName)
        else
          Showmessage ('File does not exist, please select another one,');
      end
      else
      begin
        ShowMessage('No output file selected');
        exit;
      end;
      StatusText ('The output file can be imported into spreadsheets');
      OutputTabsheet.Hide;
      OutputMemo.Lines.Clear;
      for k:=1 to DMRainOff.NrOfLines do
          OutputMemo.Lines.Add(DMRainOff.FileLine[k-1]);
      DMRainOff.OutputFilename:=DMRainOff.Filename;
      SetInitialDir (GetCurrentDir);
      OutputOpened := true;
      ViewGraphButton.Visible := true;
      SeeGraphButton.Visible := true;
      CommentForm.Visible := false;
      CommentButton.Enabled := false;
      OutputTabsheet.Show
end; {TRainForm.OutputOpenActionExecute}



procedure TRainForm.OutputOpenForGraphicsExecute(Sender: TObject);
var k : integer;
begin
  inherited;
  if OutputOpenDialog.Execute then
     begin
        DMRainOff.Filename := RainForm.OutputOpenDialog.Files.Strings[0];
        if FileExists (DMRainOff.Filename) then
          DMRainOff.ReadOutputLines (DMRainOff.FileName)
        else
          Showmessage ('File does not exist, please select another one,');
      end
      else
      begin
        ShowMessage('No output file selected');
        exit;
      end;
      StatusText ('The output file can be imported into spreadsheets');
      OutputMemo.Lines.Clear;
      for k:=1 to DMRainOff.NrOfLines do
      begin
        OutputMemo.Lines.Add(DMRainOff.FileLine[k-1]);
      end;
      DMRainOff.OutputFilename:=DMRainOff.Filename;
      SetInitialDir (GetCurrentDir);
      GraphImage.Visible := false;
      PictureImage.Visible:= false;
      GraphOpened := false;
      CommentButton.Enabled :=false;
      OutputOpened := true;
      ViewGraphButton.Visible := true;
      OutputOpenedForGraphics := true;
      CommentForm.Visible := false;
      CommentButton.Enabled := false;
      ShowGraphicsTab;
end; {TRainForm.OutputOpenForGraphicsExecute}


procedure TRainForm.GraphOpenActionExecute(Sender: TObject);
begin
  inherited;
     GraphSaveAction.Enabled := false;
     Panel1.Visible := false;
     Panel2.Visible := false;
     Panel3.Visible := false;
     SelectButton.Enabled := false;
     if GraphOpenDialog.Execute then
     begin
        DMRainOff.Filename := RainForm.GraphOpenDialog.Files.Strings[0];
        if FileExists (DMRainOff.Filename) then
          PictureImage.Picture.LoadFromFile(DMRainOff.FileName)
        else
        begin
          Showmessage ('File does not exist, please select another one');
          exit;
        end;
      end
      else
      begin
        ShowMessage('No graphics file selected');
        exit;
      end;
      SetInitialDir (GetCurrentDir);
      GraphOpened :=true;
      GraphImage.Visible := false;
      PictureImage.Visible:= true;
      CommentForm.Visible := false;
      CommentButton.Enabled := false;
      GraphicsTabsheet.Show;
end; {TRainForm.GraphOpenActionExecute}


procedure TRainForm.GraphSaveActionExecute(Sender: TObject);
var Result : boolean;
    FigureFile : string;
begin
  inherited;
      if GraphSaveDialog.Execute then
      begin FigureFile := GraphSaveDialog.Files.Strings[0];
        if FileExists(FigureFile) then
           Result := DMRainOff.Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          GraphImage.Picture.SaveToFile(FigureFile);
          Showmessage ('The graph was saved in  ' + FigureFile);
          SetInitialDir (GetCurrentDir);
        end;
      end
      else Showmessage ('The graph was not saved');
end; {TRainForm.GraphSaveActionExecute}


procedure TRainForm.AlfaButtonClick(Sender: TObject);
begin
  inherited;
  AlfaForm.show;
end;



end.

